#pragma once
#include "IntTypes.h"
#include <vector>
#include <string>

class ISmartDnsProxy
{
public:
	ISmartDnsProxy() {}
	virtual ~ISmartDnsProxy() {}
	
public:
	virtual void setPreResolveHosts(std::vector<std::string>& hosts) = 0;
	virtual void getByNameWithReqId(const std::string& host, uint32_t timeoutMs, int32_t flag, uint64_t reqId, std::vector<std::string>& ipVecs) = 0;
	virtual void getByName(const std::string& host, std::vector<std::string>& ipVecs) = 0;
	virtual uint64_t getNextRequstId() = 0;
	virtual void cancelRequest(const std::string& host, uint64_t reqId) = 0;
	virtual std::string getClientWanIP() = 0;
	virtual void release() = 0;
};
